package de.hhhammer.playtime.ng.serialization;

import de.hhhammer.playtime.ng.player.DeserializationPlayer;
import de.hhhammer.playtime.ng.player.Player;
import de.hhhammer.playtime.ng.serialization.deserializer.JsonDeserializer;
import de.hhhammer.playtime.ng.serialization.serializer.JsonSerializer;
import de.hhhammer.playtime.ng.serialization.serializer.Serializer;

import java.time.format.DateTimeFormatter;

public final class JsonSerializationFactory implements SerializationFactory {

    private final DateTimeFormatter dateTimeFormatter;

    public JsonSerializationFactory(final DateTimeFormatter dateTimeFormatter) {
        this.dateTimeFormatter = dateTimeFormatter;
    }


    @Override
    public Player createDeserializer(final String serialized) {
        return new DeserializationPlayer(new JsonDeserializer(serialized), dateTimeFormatter);
    }

    @Override
    public Serializer createSerializer(final Player player) {
        return new JsonSerializer(player, dateTimeFormatter);
    }
}
