package de.hhhammer.playtime.ng.player;

import de.hhhammer.playtime.ng.serialization.deserializer.JsonDeserializer;
import de.hhhammer.playtime.ng.serialization.serializer.JsonSerializer;
import org.junit.jupiter.api.Test;

import java.time.Duration;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.UUID;

public class PlayerDeserializationPlayerDeserializerSerializerAndTest implements PlayerTestHelper {

    @Test
    void shouldBeEqualAfterSerializationAndDeserialization() {
        final var dateTimeFormatter = DateTimeFormatter.ISO_DATE_TIME;
        final var player = new PlayTimePlayer(UUID.randomUUID(), "name", Duration.ofMinutes(1), LocalDateTime.now());
        final var serializedPlayer = new JsonSerializer(player, dateTimeFormatter).serialize();
        final var deserializedPlayer = new DeserializationPlayer(new JsonDeserializer(serializedPlayer), dateTimeFormatter);
        assertEqual(player, deserializedPlayer);
    }
}
